// RootflyGraphics.h: interface for the RootflyGraphics class.
//
//////////////////////////////////////////////////////////////////////

#include "DataStructures.h"
#include "ImageToWindowConverter.h"

#if !defined(AFX_ROOTFLYGRAPHICS_H__A56BBC24_46B8_41A2_9CDD_17049F680F3D__INCLUDED_)
#define AFX_ROOTFLYGRAPHICS_H__A56BBC24_46B8_41A2_9CDD_17049F680F3D__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class RootflyGraphics  
{
public:
	RootflyGraphics();
  virtual ~RootflyGraphics();

  void Initialize( const ImageClientConverter&, const Settings&, const RootflyData& );
  void DrawSelectedRoot(CDC& dc, int selected_id, int mode, CPoint mouse_point, bool xtend_tail) const;
  void DrawAllRoots(CDC& dc, int mode, bool zoomed) const;
  void DrawCurrentRoot(CDC& dc, int mode, const RootInstance &ri, CPoint mouse_point) const;
  void DrawLine( std::vector<RPoint> line, COLORREF c, CDC& dc ) const;
  void DrawLine( std::vector<RPoint> line, COLORREF c, int width, CDC& dc ) const;
  void DrawPoint(const RPoint* point, CDC& dc) const;
  void DrawDiameter(const RootInstance* inst, bool selected, CDC& dc ) const;
  void SetClipRegion(CDC& dc, bool zoomed);
  void FillImageDisplayAreaWithGray(CDC& dc, CRect &rect);
  bool RootIsInCurrentWindow( const RootInstance &inst ) const;


private:
  const ImageClientConverter *rfy_dlg_conv;
  const Settings *rfy_dlg_settings;
  const RootflyData *rfy_dlg_data;
};

#endif // !defined(AFX_ROOTFLYGRAPHICS_H__A56BBC24_46B8_41A2_9CDD_17049F680F3D__INCLUDED_)
